/*******************************************************************************/
/*                                                                             */
/*    Copyright (c) 2007 Analog Devices, Inc.  All Rights Reserved.            */
/*    This software is proprietary to Analog Devices, Inc. and its 			   */
/*	  licensors.                                  							   */
/*                                                                             */
/*    CHANGES:  07/02/2007  1.00  - initial public release  				   */
/*																			   */
/*******************************************************************************/

/*********************************************************************

Include files

*********************************************************************/

#include <ccblkfn.h>
#include "main.h"
#include "system.h"

#define FLOW_1 0x1000
#define SLEN_32 0x001f

/*
	Function: Init_Sport1
	
	Description:Configure Sport1 for I2S mode, to transmit/receive data 	//
				to/from the ADC/DAC.Configure Sport for external clocks and //
				frame syncs.
*/
void Init_DMA_Sport1(char * iTxBuffer1)
{
    *pSPORT1_TCR1 = TFSR | ITFS | ITCLK;
	*pSPORT1_TCR2 = SLEN_32 | TSFSE;
	*pSPORT1_TCLKDIV = 0x000F;
	*pSPORT1_TFSDIV = 0x0000;
	
	// Configure DMA3
	// 32-bit transfers, Interrupt on completion, Autobuffer mode
	*pDMA2_3_CONFIG = FLOW_1 |WDSIZE_32| DI_EN;
	
	// Start address of data buffer
	*pDMA2_3_START_ADDR = iTxBuffer1;
	
	// DMA loop count
	*pDMA2_3_X_COUNT = SPORT_BUFFER_SIZE/4;//BUFFER_SIZE;
	
	// DMA loop address increment
	*pDMA2_3_X_MODIFY = 4;
}

/*
	Function: void Enable_DMA_Sport1(void)
	
	Description: Enable DMA3, DMA4, Sport1 TX
*/
void Enable_DMA_Sport1(void)
{
	// enable DMAs
	*pDMA2_3_CONFIG	= (*pDMA2_3_CONFIG | DMAEN);
	ssync();
	*pSPORT1_TCR1 	= (*pSPORT1_TCR1 | TSPEN);
	ssync();
}

/*
	Function:void Disable_Sport1(void)
	
	Description:
*/
void Disable_Sport1(void)
{
	
	*pSPORT1_TCR1 	= (*pSPORT1_TCR1 & 0x0);
	ssync();
	*pDMA2_3_CONFIG	= (*pDMA2_3_CONFIG & 0x0);
	ssync();
	
}
